# Recommendations for Efficient Updates

When you have a heavily animated graphic that takes multiple seconds to render, consider pre-rendering values in advance. As soon as you know the value of the variable you will want to display, send a `render` action for that specific variable to the specific title and then wait before sending the actual `update` or `animateIn` action.

You can determine the current render status for any title by using the `renderStatus` command described under the `scheduleCommand` section.

Additionally, whenever your graphic is heavily dependent on numerical data, consider setting up those numbers as [pattern variables](/captivate-api/captivate-controller-reference/pattern-variables.md) in your graphic, in your controller's XML definition, or issuing a `updateInputDefinition` command to add a pattern to an existing variable. When you use a pattern for a text variable, all possible values of each digit are rendered separately in advance, so they can be used immediately when needed. As a side benefit, you also get your animation applied to each digit independently.

**Summary:**

* Set up your graphic to use pattern variables for every numeric value that needs to update efficiently.
* Whenever you know some variable data in advance of when it needs to be displayed and using a pattern doesn't make sense (e.g. names in a baseball line-up, or a team’s jersey numbers), send a `render` action for each possible value of that variable.

By sending `render` as soon as you can, you ensure your title will be completely ready for any data you send to it.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.newbluefx.com/captivate-api/javascript-api-reference/using-the-servicehandler/recommendations-for-efficient-title-updates.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
